import numpy as np
from netCDF4 import Dataset

# path = '/gpfs/scratch/bsc32/bsc32786/pisces1d/ICEp_LAB1d/'
#path = '/esarchive/scratch/mfalls/pisces1d/'

#MOD = Dataset('/gpfs/scratch/bsc32/bsc32786/pisces1d/cross_testing/LAB1d_def/runs/20210611141713/PISCES_5d_19600101_19641231_ptrc_T.nc')
#MOD = Dataset('/esarchive/scratch/mfalls/pisces1d/logs/O5_LAB3/a3nj/PISCES_5d_19600101_19641231_ptrc_T.ncdef')
MOD = Dataset('/gpfs/scratch/bsc32/bsc32786/a3r1/EXP00/D02_P04/PISCES_5d_19600101_19641231_ptrc_T.nc')
#OBS = Dataset('/gpfs/scratch/bsc32/bsc32340/pisces1d/obs/Mprof_6901486_L75_from_A18_5days_2015-01-01_2015-12-31reg.nc') # LAB3
OBS = Dataset('/gpfs/scratch/bsc32/bsc32340/pisces1d/obs/Mprof_6901527_L75_from_A18_5days_2016-01-01_2016-12-31reg.nc') # LAB1
#OBS = Dataset('/gpfs/scratch/bsc32/bsc32340/pisces1d/obs/Mprof_6901527_L75_from_A18_5days_2014-01-01_2014-12-31reg.nc') # LAB2

def getobsdata(A):
    A[A == 0] = np.nan

    A=np.log10(A)
    mn = np.nanmean(A)
    std = np.nanstd(A)
    return A,mn,std

def editmoddata(arr,d,s, mn=None, std=None):
    arr=arr[:,:np.shape(d)[0]]
    arr=arr[-s:]
    arr[arr == 200000039192547557376] = np.nan
    arr=np.log10(arr)
    if mn:
        return arr
    else:
        mn = np.nanmean(arr)
        std = np.nanstd(arr)
        return arr, mn, std

bPOCobs = np.array(OBS.variables['bpoc'])
bPOCobs=bPOCobs[:,:46]
bPOCobs, bPOCobsmean, bPOCobsstd = getobsdata(bPOCobs)
depths = np.array(OBS.variables['deptht'])
S = np.shape(bPOCobs)[0]

bPOCmod = (np.array(MOD.variables['GOC'])[-S:, :, 1, 1]+np.array(MOD.variables['ZOO2'])[-S:, :, 1, 1])
bPOCmod=bPOCmod[:,:46]
bPOCmod=editmoddata(bPOCmod,depths,S, mn=bPOCobsmean, std=bPOCobsstd)

B = np.nanmean(bPOCmod - bPOCobs)
R = float(np.ma.corrcoef(np.ma.masked_invalid(bPOCobs.flatten()), np.ma.masked_invalid(bPOCmod.flatten()))[0,1])
print(B,R)

sPOCobs = np.array(OBS.variables['spoc'])
sPOCobs=sPOCobs[:,:46]
sPOCobs, sPOCobsmean, sPOCobsstd = getobsdata(sPOCobs)
depths = np.array(OBS.variables['deptht'])
#S = np.shape(sPOCobs)[0]

sPOCmod = (np.array(MOD.variables['POC'])[-S:, :, 1, 1]+np.array(MOD.variables['PHY2'])[-S:, :, 1, 1]+np.array(MOD.variables['PHY'])[-S:, :, 1, 1]+np.array(MOD.variables['ZOO'])[-S:, :, 1, 1])
sPOCmod=sPOCmod[:,:46]
sPOCmod=editmoddata(sPOCmod,depths,S, mn=sPOCobsmean, std=sPOCobsstd)

# print(np.array(MOD.variables['POC'])[-S:, :, 1, 1])
# print(np.array(MOD.variables['PHY2'])[-S:, :, 1, 1])
# print(np.array(MOD.variables['PHY'])[-S:, :, 1, 1])
# print(np.array(MOD.variables['ZOO'])[-S:, :, 1, 1])

B = np.nanmean(sPOCmod - sPOCobs)
R = float(np.ma.corrcoef(np.ma.masked_invalid(sPOCobs.flatten()), np.ma.masked_invalid(sPOCmod.flatten()))[0,1])
print(B,R)